function Mesh = makeMesh(N)

    x = linspace(0,1,2*N+1);
    xs = repmat(x(1:2:end), 1, N+1); xs = xs(:);
    ys = repmat(x(1:2:end), N+1, 1); ys = ys(:);

    Mesh.Coordinates = [xs, ys];
    M = (N+1)^2;

    xs = repmat(x(2:2:end), 1, N); xs = xs(:);
    ys = repmat(x(2:2:end), N, 1); ys = ys(:);

    Mesh.Coordinates = [Mesh.Coordinates; xs, ys];

    Mesh.Elements = [];
    for i = 0:N-1
        Mesh.Elements = [Mesh.Elements; [i*(N+1)+1:(i+1)*(N+1)-1; i*(N+1)+2:(i+1)*(N+1); M+i*N+1:M+(i+1)*N]'];
        Mesh.Elements = [Mesh.Elements; [i*(N+1)+1:(i+1)*(N+1)-1; M+i*N+1:M+(i+1)*N; (i+1)*(N+1)+1:(i+2)*(N+1)-1]'];
        Mesh.Elements = [Mesh.Elements; [i*(N+1)+2:(i+1)*(N+1); (i+1)*(N+1)+2:(i+2)*(N+1); M+i*N+1:M+(i+1)*N]'];
        Mesh.Elements = [Mesh.Elements; [M+i*N+1:M+(i+1)*N; (i+1)*(N+1)+2:(i+2)*(N+1); (i+1)*(N+1)+1:(i+2)*(N+1)-1]'];
    end

    Mesh.ElemFlag = ones(size(Mesh.Elements,1),1);         
    Mesh = add_Edges(Mesh);
    Loc = get_BdEdges(Mesh);
    Mesh.BdFlags = zeros(size(Mesh.Edges,1),1); 
    Mesh.BdFlags(Loc) = -1;
    Mesh = add_Edge2Elem(Mesh);

end
